package models

import (
	"git.nobla.cn/golang/aeus-admin/pb"
	"git.nobla.cn/golang/aeus-admin/types"
)

type (
	User struct {
		pb.UserModel
	}
	Menu struct {
		pb.MenuModel
	}
	Department struct {
		pb.DepartmentModel
	}
	Role struct {
		pb.RoleModel
	}
	Permission struct {
		pb.PermissionModel
	}
	RolePermission struct {
		pb.RolePermissionModel
	}

	Setting struct {
		pb.SettingModel
	}
)

func (m *User) GetMenu() *types.Menu {
	return &types.Menu{
		Name:   "OrganizeUser",
		Parent: "Organize",
	}
}

func (m *Menu) GetMenu() *types.Menu {
	return &types.Menu{
		Name:   "OrganizeMenu",
		Parent: "Organize",
	}
}

func (m *Department) GetMenu() *types.Menu {
	return &types.Menu{
		Name:   "OrganizeDepartment",
		Parent: "Organize",
	}
}

func (m *Role) GetMenu() *types.Menu {
	return &types.Menu{
		Name:   "OrganizeRole",
		Parent: "Organize",
	}
}

func (m *Permission) GetMenu() *types.Menu {
	return &types.Menu{
		Name:   "OrganizePermission",
		Parent: "Organize",
		Hidden: true,
	}
}

func (m *RolePermission) GetMenu() *types.Menu {
	return &types.Menu{
		Name:   "OrganizeRolePermission",
		Parent: "Organize",
		Hidden: true,
	}
}

func (m *Setting) GetMenu() *types.Menu {
	return &types.Menu{
		Name:   "SystemSetting",
		Parent: "System",
	}
}

func (m *Setting) ModuleName() string {
	return "system"
}
